package com.jjt.biz.controller;

import cn.hutool.json.JSONUtil;
import com.jjt.biz.service.IApiYrService;
import com.jjt.biz.vo.YrCompareReq;
import com.jjt.biz.vo.YrTwinVO;
import com.jjt.common.constant.CacheConstants;
import com.jjt.common.core.controller.BaseController;
import com.jjt.common.core.domain.R;
import com.jjt.common.core.redis.RedisCache;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;

/**
 * swagger 用户测试方法
 *
 * @author ruoyi
 */
@Api(tags = "染整线数字孪生数据接口")
@RestController
@Slf4j
public class ApiYrController extends BaseController {
    @Resource
    private IApiYrService service;
    @Resource
    private RedisCache redisCache;
    @Value("${local.rzCompare}")
    private String path;

    @ApiOperation("染整线数字孪生")
    @GetMapping("/api/yr/data")
    @CrossOrigin(origins = "*")
    @ResponseBody
    public R<?> data() {
        YrTwinVO vo = redisCache.getCacheObject(CacheConstants.RZ_MOCK);
        return R.ok(vo);
    }

    @ApiOperation("染整线数AI比对")
    @RequestMapping("/api/yr/compare")
    @CrossOrigin(origins = "*")
    @ResponseBody
    public R<?> compare(@RequestBody YrCompareReq vo) throws IOException {
        String str = new String(Files.readAllBytes(Paths.get(path)));
        return R.ok(JSONUtil.parseArray(str));
    }

}
